# react-admin-ts

**English** | [中文](./README-zh_CN.md)

> A basic react admin template with  vite2 & ant4 UI & axios & svg-icon& permission control & lint

A new  generation admin  construct   using  react17+vite2+element-plus ，It's fast!

Use eslint+prettier+gitHooks format and verification code to improve code standardization and development efficiency


## Update log

```javascript
//10-08
add error log collection func
```

## Online experience

[github address](https://github.com/jzfai/react-admin-ts.git)

[Access address](http://8.135.1.141/react-admin-ts)

国内体验地址：http://8.135.1.141/react-admin-ts

github 地址：  https://github.com/jzfai/react-admin-ts.git

## Demo

 ---- Let's look at the loading speed and the size of the built package first.：

![template-speed-analysis](http://8.135.1.141/file/images/react-template-speed-analysis.png)

![template-demo](http://8.135.1.141/file/images/react-template-demo.png)


## Related items

The framework is available in js, ts and plus versions
- js version：[vue3-element-admin](https://github.com/jzfai/vue3-admin-template.git)
- ts version：[vue3-element-ts](https://github.com/jzfai/vue3-admin-ts.git)
- js version for plus：[vue3-element-plus](https://github.com/jzfai/vue3-admin-plus.git)
- react version： [react-admin-template](https://github.com/jzfai/react-admin-template.git)
- java Micro-service background data：[micro-service-plus](https://github.com/jzfai/micro-service-plus)
> development and  experience：two words  Really fragrant！！！！！

## Documents

-- Efforts are being made to develop documents ......

You can refer to first：[documentation of vue-admin-template ](https://juejin.im/post/59097cd7a22b9d0065fb61d2)

#### Difference from traditional react admin

1.Simple routing configuration, routing generation and page rendering can be completed in one configuration

2.Using react hooks, the writing method is more flexible, simple, and easier to maintain and migrate

3.Using vite2 instead of webpack is easier to configure, pack and run faster


[Comparison of packaging speed between vite2 and webpack](https://github.com/jzfai/vue3-admin-template/issues/2)

## Build Setup

```bash
# clone the project
git clone https://github.com/jzfai/react-admin-ts.git

# enter the project directory
cd react-admin-ts

# install dependency(Recommend use yarn)
yarn

# develop
yarn run dev
```

using the browser to open http://localhost:5001

## Build

```bash
# build for dev environment
yarn run build-serve

# build for production environment
yarn run  build
```

## Others

```bash
# preview the dev environment effect
yarn run preview:build-serve

# preview the release environment effect
yarn run preview

# code format check
yarn run lint

```

## Extra

Architecture development is not easy. If you feel good, please give me a compliment. The architecture is still being improved. Welcome to join me in development and become Contributors together! ! ! !

## Browsers support

Modern browsers and Internet Explorer 11+.

| [<img src="https://raw.githubusercontent.com/alrra/browser-logos/master/src/edge/edge_48x48.png" alt="IE / Edge" width="24px" height="24px" />](http://godban.github.io/browsers-support-badges/)</br>IE / Edge | [<img src="https://raw.githubusercontent.com/alrra/browser-logos/master/src/firefox/firefox_48x48.png" alt="Firefox" width="24px" height="24px" />](http://godban.github.io/browsers-support-badges/)</br>Firefox | [<img src="https://raw.githubusercontent.com/alrra/browser-logos/master/src/chrome/chrome_48x48.png" alt="Chrome" width="24px" height="24px" />](http://godban.github.io/browsers-support-badges/)</br>Chrome | [<img src="https://raw.githubusercontent.com/alrra/browser-logos/master/src/safari/safari_48x48.png" alt="Safari" width="24px" height="24px" />](http://godban.github.io/browsers-support-badges/)</br>Safari |
| --------- | --------- | --------- | --------- |
|Edge| last 2 versions| last 2 versions| last 2 versions

## Discussion and Communication
[WeChat group](http://8.135.1.141/file/images/wx-groud.png)

## License

[MIT](https://github.com/jzfai/react-admin-ts/blob/master/LICENSE) license.

Copyright (c) 2021-present  kuanghua

